package CollectionGenericObjects;

import Drawnings.DrawningTruck;

import javax.swing.*;
import java.awt.*;
import java.awt.image.BufferedImage;
import java.util.Random;

public abstract class AbstractCompany {
    protected final int _placeSizeWidth = 210;
    protected final int _placeSizeHeight = 80;
    protected int _pictureWidth;
    protected int _pictureHeight;
    public ICollectionGenericObjects<DrawningTruck> _collection = null;
    private int GetMaxCount() {
        return _pictureWidth / _placeSizeWidth * (_pictureHeight / _placeSizeHeight / 2);
    };

    public AbstractCompany(int picWidth, int picHeight, ICollectionGenericObjects<DrawningTruck> collection) {
        _pictureWidth = picWidth;
        _pictureHeight = picHeight;
        _collection = collection;
        _collection.SetMaxCount(GetMaxCount(), (Class) DrawningTruck.class);
    }
    public DrawningTruck GetRandomObject() {
        Random rnd = new Random();
        return _collection.Get(rnd.nextInt(GetMaxCount()));
    }

    public void Show(Graphics g) {
        DrawBackground(g);
        SetObjectsPosition();
        for (int i = 0; i < _collection.Count(); i++) {
            DrawningTruck obj = _collection.Get(i);
            if (obj != null) {
                obj.DrawTransport(g);
            }
        }
    }

    protected abstract void DrawBackground(Graphics g);
    protected abstract void SetObjectsPosition();
}