package CollectionGenericObjects;

import Drawnings.DrawningTruck;

import java.awt.*;

public class AutoParkService extends AbstractCompany {
    public AutoParkService(int picWidth, int picHeight, ICollectionGenericObjects<DrawningTruck> collection) {
        super(picWidth, picHeight, collection);
    }
    @Override
    protected void DrawBackground(Graphics g) {
        g.setColor(Color.black);
        ((Graphics2D) g).setStroke(new BasicStroke(4));
        for (int i = 0; i < _pictureHeight / _placeSizeHeight / 2; i++)
        {
            g.drawLine(0, i * _placeSizeHeight * 2, _pictureWidth / _placeSizeWidth * _placeSizeWidth, i *  _placeSizeHeight * 2);
            for (int j = 0; j < _pictureWidth / _placeSizeWidth + 1; ++j)
            {
                g.drawLine(j * _placeSizeWidth, i * _placeSizeHeight * 2, j * _placeSizeWidth, i * _placeSizeHeight * 2 + _placeSizeHeight + 20);
            }
        }
        ((Graphics2D) g).setStroke(new BasicStroke(1));
    }

    @Override
    protected void SetObjectsPosition() {
        int nowWidth = 0;
        int nowHeight = 0;

        for (int i = 0; i < _collection.Count(); i++)
        {
            if (nowHeight > _pictureHeight / _placeSizeHeight)
            {
                return;
            }
            if (_collection.Get(i) != null)
            {
                _collection.Get(i).SetPictureSize(_pictureWidth, _pictureHeight);
                _collection.Get(i).SetPosition(_placeSizeWidth * nowWidth + 30, nowHeight * _placeSizeHeight * 2 + 20);
            }

            if (nowWidth < _pictureWidth / _placeSizeWidth - 1) nowWidth++;
            else
            {
                nowWidth = 0;
                nowHeight++;
            }
        }
    }
}
