package CollectionGenericObjects;

import java.util.*;

public class StorageCollection<T> {
    private Map<String, ICollectionGenericObjects<T>> _storages;
    public Set<String> Keys() {
        return _storages.keySet();
    }
    public StorageCollection() {
        _storages = new HashMap<>();
    }
    public void AddCollection(String name, CollectionType collectionType) {
        if (name == null || _storages.containsKey(name)) {
            return;
        }
        switch (collectionType) {
            case None:
                return;
            case Massive:
                _storages.put(name, new MassiveGenericObjects<T>());
                return;
            case List:
                _storages.put(name, new ListGenericObjects<T>());
                return;
        }
    }
    public void DelCollection(String name) {
        if (_storages.containsKey(name)) {
            _storages.remove(name);
        }
    }
    public ICollectionGenericObjects<T> GetCollectionObject(String name) {
        if (_storages.containsKey(name)) {
            return _storages.get(name);
        }
        return null;
    }
}
