package MovementStrategy;

public class MoveToBorder extends AbstractStrategy {
    @Override
    protected boolean IsTargetDestination() {
        ObjectParameters objParameters = GetObjectParameters();
        if (objParameters == null) {
            return false;
        }
        return objParameters.RightBorder() + GetStep() >= FieldWidth
                && objParameters.DownBorder() + GetStep() >= FieldHeight;
    }

    @Override
    protected void MoveToTarget() {
        ObjectParameters objParameters = GetObjectParameters();
        if (objParameters == null) {
            return;
        }
        int diffX = objParameters.RightBorder();
        if (Math.abs(diffX) > GetStep()) {
            if (diffX < 0) {
                MoveLeft();
            } else {
                MoveRight();
            }
        }
        int diffY = objParameters.DownBorder();
        if (Math.abs(diffY) > GetStep()) {
            if (diffY < 0) {
                MoveUp();
            } else {
                MoveDown();
            }
        }
    }
}
